/* programma principale */

#define H3CALC_VERSION "v0.1.14"
#define H3CALC_DATE	   "26/08/2003"

#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include "h3calc-shared.h"  /* macro e funzioni condivise */

extern void yyrestart(FILE *f);
extern int yyparse();

int main(int argc, char ** argv)
{
	int result; 
	FILE *inputfile = NULL;
	
	dprintf("argc=%d\n",argc);
	
	if (argc >=2) {
		if ((strcmp(argv[1],"-h")==0) || (strcmp(argv[1],"--help")==0) || (argc>2)) {
			printf("\n** H3CALC version %s - %s - by Gerosa Riccardo **\n\n",H3CALC_VERSION,H3CALC_DATE);
			printf(  " h3calc is a scriptable scientific calculator,\n");
			printf(  " the scripting language is a sort of BASIC.\n\n");
			printf(  "SYNTAX:\n");
			printf(  " \"h3calc\"\n        ... without any parameters runs in interactive mode\n");
			printf(  " \"h3calc filename.h3c\"\n        ... with one parameter runs a program\n");
			printf(  " \"h3calc --help\"\n        ... shows this help screen\n");
			exit(0);
		}
		inputfile = fopen(argv[1],"r");
		if (inputfile == NULL) {
			printf("*ERROR: can't open file \"%s\"\n",argv[1]);
			exit(1);
		}
		yyrestart(inputfile);
	}
	
	if (argc == 1) {
		printf("\n-- h3calc %s -- %s -- by Riccardo Gerosa --\n",H3CALC_VERSION,H3CALC_DATE);
		printf(  "-- interactive mode (you can also type h3calc filename.h3c) --\n");
		printf(  "-- type \"help\" for help, \"quit\" to quit --\n\n");
	}
	
	setvar("golden_ratio",1.6180339887498948482045868343656,TRUE);
	setvar("e",2.7182818284590452353602874713526,TRUE);
	setvar("pi",3.1415926535897932384626433832795,TRUE);
	setvar("false",0.0,TRUE);
	setvar("true",1.0,TRUE);
	
	do {
		if (argc == 1) printf("> ");
		result=yyparse();
		dprintf("result=%d\n",result);
	} while ((result==0) || (result==1)); /* 0 = ok    1 = error   2 = quit */
	
	if (inputfile!=NULL) fclose(inputfile);
  
	return 0;
}
