/* macro e funzioni condivise */

#ifndef H3CALCSHAREDH
#define H3CALCSHAREDH

#define TRUE  1
#define FALSE 0


/* scommentare la riga seguente per visualizzare i passaggi intermedi */
/* #define DEBUG */

/* definizione della lunghezza massima di un nome di variabile */
#define MAX_VARIABLE_NAME_LENGTH 255

typedef union yystypeunion /* associa a un token un valore o un nome di variabile*/
{
	double	value;
   	char 	name[MAX_VARIABLE_NAME_LENGTH+1];
} YYSTYPEunion;

#define YYSTYPE YYSTYPEunion

#ifdef DEBUG
	#define dprintf(...) printf (__VA_ARGS__)
#else 
	#define dprintf(...) ;
#endif

int yylex();
int yyerror(char *s);

void strcpynz(char *dest, char *src,int maxlen);
/* copia al massimo maxlen caratteri dalla stringa src alla stringa dest,
   garantisce che la stringa dest risultante sia zero-terminata, 
   quindi la dimensione di dest deve essere almeno maxlen */
   
double fatt(double x);
/* calcola il fattoriale di x */
   
typedef struct variableinfo
{
   	char 	name[MAX_VARIABLE_NAME_LENGTH+1];
	double	value;
	int 	isconstant;
	struct variableinfo *next;
} variableinfo;

int setvar(char* name,double value,int isconstant);
struct variableinfo *getvar(char* name);
int showvars();
int showconsts();

#endif
